unit uMain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  uThreads;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    stComputing2: TStaticText;
    stMonitors: TStaticText;
    stComputing: TStaticText;
    stThreads: TStaticText;
    stStatus: TStaticText;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  Form1: TForm1; 

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
  if Manager<>nil then exit;
  Manager:=TMonitorThread.Create;
  Manager.Execute(Command(mcSetCount,50));
  stMonitors.Caption:='1';
  stThreads.Caption:=IntToStr(Manager.Threads);
  stComputing.Caption:=IntToStr(Manager.Computing);
  stComputing2.Caption:=IntToStr(Manager.Computing2);
  stStatus.Caption:=FMT_STATUS[Manager.Status];
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if Manager=nil then begin
    stMonitors.Caption:='';
    stThreads.Caption:='';
    stComputing.Caption:='';
    stComputing2.Caption:='';
    stStatus.Caption:='Not assigned';
    exit;
  end;
  stThreads.Caption:=IntToStr(Manager.Threads);
  Manager.Execute(Command(mcStart,0));
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  if Manager=nil then begin
    stMonitors.Caption:='';
    stThreads.Caption:='';
    stComputing.Caption:='';
    stComputing2.Caption:='';
    stStatus.Caption:='Not assigned';
    exit;
  end;
  Manager.Execute(Command(mcStop,0));
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  if Manager=nil then begin
    stMonitors.Caption:='';
    stThreads.Caption:='';
    stComputing.Caption:='';
    stComputing2.Caption:='';
    stStatus.Caption:='Not assigned';
    exit;
  end;
  stStatus.Caption:=FMT_STATUS[Manager.Status];
  stThreads.Caption:=IntToStr(Manager.Threads);
  stComputing.Caption:=IntToStr(Manager.Computing);
  stComputing2.Caption:=IntToStr(Manager.Computing2);
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  if Manager=nil then begin
    stMonitors.Caption:='';
    stThreads.Caption:='';
    stComputing.Caption:='';
    stComputing2.Caption:='';
    stStatus.Caption:='Not assigned';
    exit;
  end;
  Manager.Execute(Command(mcDestroy,0));
  Manager:=nil;
end;

end.

